---
title: Document.implementation
slug: Web/API/Document/implementation
tags:
  - API
  - DOM
  - Document
  - NeedsContent
  - Property
  - Reference
---
<div>{{ ApiRef("DOM") }}</div>

<p>The <code><strong>Document.implementation</strong></code> property returns a {{domxref("DOMImplementation")}} object associated with the current document.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>DOMImpObj</var> = <em>document</em>.implementation;
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">var modName = "HTML";
var modVer = "2.0";
var conformTest = document.implementation.hasFeature( modName, modVer );

alert( "DOM " + modName + " " + modVer + " supported?: " + conformTest );

// alerts with: "DOM HTML 2.0 supported?: true" if DOM Level 2 HTML module is supported.
</pre>

<p>A list of module names (e.g., Core, HTML, XML, etc.) is available in the DOM Level 2 <a href="http://www.w3.org/TR/DOM-Level-2-Core/introduction.html#ID-Conformance-h2">Conformance Section</a>.</p>

<h2 id="Notes">Notes</h2>

<p>The W3C's DOM Level 1 Recommendation only specified the <code>hasFeature</code> method, which is one way to determine if a DOM module is supported by a browser (see example above and <a href="http://www.w3.org/2003/02/06-dom-support.html">What does your user agent claim to support?</a>). If available, other <code>DOMImplementation</code> methods provide services for controlling things outside of a single document. For example, the <code>DOMImplementation</code> interface includes a <code>createDocumentType</code> method with which DTDs can be created for one or more documents managed by the implementation.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-document-implementation', 'document.implementation')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.implementation")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Starting with Gecko 19.0 {{geckoRelease("19.0")}} the {{domxref("DOMImplementation.hasFeature","hasFeature")}} method will always return true.</li>
</ul>
